import type { FlatConfig } from "@typescript-eslint/utils/ts-eslint";
declare function genConf(plg: FlatConfig.Plugin): {
    recommended: {
        rules: {
            'script-eslint-rules/deprecation': "warn";
            'script-eslint-rules/extract-lone-expressions': "warn";
            'script-eslint-rules/no-anonymous-classes': "error";
            'script-eslint-rules/no-class-computed-properties': "error";
            'script-eslint-rules/no-func-declaration': "warn";
            'script-eslint-rules/no-multiple-array-check': "warn";
            'script-eslint-rules/no-nested-ifs': "warn";
            'script-eslint-rules/no-new-promise': "warn";
            'script-eslint-rules/no-relative-imports': "warn";
        };
        plugins: {
            readonly 'script-eslint-rules': FlatConfig.Plugin;
        };
    };
    strict: {
        rules: {
            'script-eslint-rules/deprecation': "error";
            'script-eslint-rules/extract-lone-expressions': "error";
            'script-eslint-rules/no-anonymous-classes': "error";
            'script-eslint-rules/no-class-computed-properties': "error";
            'script-eslint-rules/no-func-declaration': "error";
            'script-eslint-rules/no-multiple-array-check': "error";
            'script-eslint-rules/no-new-promise': "error";
            'script-eslint-rules/no-relative-imports': "error";
        };
        plugins: {
            readonly 'script-eslint-rules': FlatConfig.Plugin;
        };
    };
};
declare const _default: {
    rules: {
        deprecation: import("@typescript-eslint/utils/ts-eslint").RuleModule<"deprecated" | "deprecatedWithReason" | "deprecatedSignature" | "deprecatedSignatureWithReason", [], import("@typescript-eslint/utils/ts-eslint").RuleListener> & {
            name: "deprecation";
        };
        'extract-lone-expressions': import("@typescript-eslint/utils/ts-eslint").RuleModule<"expressionStatement", [], import("@typescript-eslint/utils/ts-eslint").RuleListener> & {
            name: "extract-lone-expressions";
        };
        'no-anonymous-classes': import("@typescript-eslint/utils/ts-eslint").RuleModule<"anonymous", [], import("@typescript-eslint/utils/ts-eslint").RuleListener> & {
            name: "no-anonymous-classes";
        };
        'no-class-computed-properties': import("@typescript-eslint/utils/ts-eslint").RuleModule<"computed", [], import("@typescript-eslint/utils/ts-eslint").RuleListener> & {
            name: "no-class-computed-properties";
        };
        'no-func-declaration': import("@typescript-eslint/utils/ts-eslint").RuleModule<"expectArrowFunction", [], import("@typescript-eslint/utils/ts-eslint").RuleListener> & {
            name: "no-func-declaration";
        };
        'no-multiple-array-check': import("@typescript-eslint/utils/ts-eslint").RuleModule<"arrayEvery" | "arraySome", [], import("@typescript-eslint/utils/ts-eslint").RuleListener> & {
            name: "no-multiple-array-check";
        };
        'no-nested-ifs': import("@typescript-eslint/utils/ts-eslint").RuleModule<"nestedIf", [], import("@typescript-eslint/utils/ts-eslint").RuleListener> & {
            name: "no-nested-ifs";
        };
        'no-new-promise': import("@typescript-eslint/utils/ts-eslint").RuleModule<"promiseConstructor", [], import("@typescript-eslint/utils/ts-eslint").RuleListener> & {
            name: "no-new-promise";
        };
        'no-relative-imports': import("@typescript-eslint/utils/ts-eslint").RuleModule<"expression" | "declaration", [{
            allowParentImports: boolean;
        }], import("@typescript-eslint/utils/ts-eslint").RuleListener> & {
            name: "no-relative-imports";
        };
    };
    genConf: typeof genConf;
};
export default _default;
