import r from "../rules/deprecation.js";
import e from "../rules/extract-lone-expressions.js";
import s from "../rules/no-anonymous-classes.js";
import o from "../rules/no-class-computed-properties.js";
import n from "../rules/no-func-declaration.js";
import t from "../rules/no-multiple-array-check.js";
import i from "../rules/no-nested-ifs.js";
import l from "../rules/no-new-promise.js";
import p from "../rules/no-relative-imports.js";
export default {
    rules: {
        deprecation: r,
        'extract-lone-expressions': e,
        'no-anonymous-classes': s,
        'no-class-computed-properties': o,
        'no-func-declaration': n,
        'no-multiple-array-check': t,
        'no-nested-ifs': i,
        'no-new-promise': l,
        'no-relative-imports': p
    },
    genConf: function(r) {
        return {
            recommended: {
                rules: {
                    'script-eslint-rules/deprecation': 'warn',
                    'script-eslint-rules/extract-lone-expressions': 'warn',
                    'script-eslint-rules/no-anonymous-classes': 'error',
                    'script-eslint-rules/no-class-computed-properties': 'error',
                    'script-eslint-rules/no-func-declaration': 'warn',
                    'script-eslint-rules/no-multiple-array-check': 'warn',
                    'script-eslint-rules/no-nested-ifs': 'warn',
                    'script-eslint-rules/no-new-promise': 'warn',
                    'script-eslint-rules/no-relative-imports': 'warn'
                },
                plugins: {
                    'script-eslint-rules': r
                }
            },
            strict: {
                rules: {
                    'script-eslint-rules/deprecation': 'error',
                    'script-eslint-rules/extract-lone-expressions': 'error',
                    'script-eslint-rules/no-anonymous-classes': 'error',
                    'script-eslint-rules/no-class-computed-properties': 'error',
                    'script-eslint-rules/no-func-declaration': 'error',
                    'script-eslint-rules/no-multiple-array-check': 'error',
                    'script-eslint-rules/no-new-promise': 'error',
                    'script-eslint-rules/no-relative-imports': 'error'
                },
                plugins: {
                    'script-eslint-rules': r
                }
            }
        };
    }
};

//# sourceMappingURL=gen.js.map