import { FlatConfig } from "@typescript-eslint/utils/ts-eslint";
export declare const plugin: {
    rules: {
        deprecation: import("@typescript-eslint/utils/ts-eslint").RuleModule<"deprecated" | "deprecatedWithReason" | "deprecatedSignature" | "deprecatedSignatureWithReason", [], import("@typescript-eslint/utils/ts-eslint").RuleListener> & {
            name: "deprecation";
        };
        'extract-lone-expressions': import("@typescript-eslint/utils/ts-eslint").RuleModule<"expressionStatement", [], import("@typescript-eslint/utils/ts-eslint").RuleListener> & {
            name: "extract-lone-expressions";
        };
        'no-anonymous-classes': import("@typescript-eslint/utils/ts-eslint").RuleModule<"anonymous", [], import("@typescript-eslint/utils/ts-eslint").RuleListener> & {
            name: "no-anonymous-classes";
        };
        'no-class-computed-properties': import("@typescript-eslint/utils/ts-eslint").RuleModule<"computed", [], import("@typescript-eslint/utils/ts-eslint").RuleListener> & {
            name: "no-class-computed-properties";
        };
        'no-func-declaration': import("@typescript-eslint/utils/ts-eslint").RuleModule<"expectArrowFunction", [], import("@typescript-eslint/utils/ts-eslint").RuleListener> & {
            name: "no-func-declaration";
        };
        'no-multiple-array-check': import("@typescript-eslint/utils/ts-eslint").RuleModule<"arrayEvery" | "arraySome", [], import("@typescript-eslint/utils/ts-eslint").RuleListener> & {
            name: "no-multiple-array-check";
        };
        'no-nested-ifs': import("@typescript-eslint/utils/ts-eslint").RuleModule<"nestedIf", [], import("@typescript-eslint/utils/ts-eslint").RuleListener> & {
            name: "no-nested-ifs";
        };
        'no-new-promise': import("@typescript-eslint/utils/ts-eslint").RuleModule<"promiseConstructor", [], import("@typescript-eslint/utils/ts-eslint").RuleListener> & {
            name: "no-new-promise";
        };
        'no-relative-imports': import("@typescript-eslint/utils/ts-eslint").RuleModule<"expression" | "declaration", [{
            allowParentImports: boolean;
        }], import("@typescript-eslint/utils/ts-eslint").RuleListener> & {
            name: "no-relative-imports";
        };
    };
    configs: {
        recommended: FlatConfig.Config;
        strict: FlatConfig.Config;
    };
    meta: {
        name: string;
    };
};
export default plugin;
