import { TSESTree as e } from "@typescript-eslint/utils";
import { AST_NODE_TYPES as t } from "@typescript-eslint/utils";
import r from "typescript";
let { getAllJSDocTags: n, isIdentifier: a, isJSDocDeprecatedTag: i, isJSDocLinkLike: o, isJSDocMemberName: p, isQualifiedName: s, isShorthandPropertyAssignment: m, TypeFormatFlags: c } = r;
import { getParserServices as d } from "@typescript-eslint/utils/eslint-utils";
import { createRule as l } from "../util/index.js";
function u(e) {
    return "string" == typeof e ? e : e.map((e)=>o(e) && e.name ? function(e) {
            let t = "", r = e;
            for(; r;){
                if (s(r) || p(r)) {
                    t = "" === t ? r.right.text : `${r.right.text}#${t}`, r = r.left;
                    continue;
                }
                if (a(r)) {
                    if ("" === t) return r.text;
                    t = `${r.text}#${t}`, r = void 0;
                    continue;
                }
                break;
            }
            return t;
        }(e.name) : e.text).join("");
}
function g(e, a, o, p, s, m) {
    if (s.flags & r.SymbolFlags.Alias && (s = o.getAliasedSymbol(s)), p.type === t.Identifier && (p.parent.type === t.CallExpression || p.parent.type === t.NewExpression) && p.parent.callee === p) {
        let t = a.esTreeNodeToTSNodeMap.get(p.parent), r = o.getResolvedSignature(t);
        if (void 0 === r) return;
        let s = r.getDeclaration();
        if (void 0 === s) return;
        for (let a of n(s, i)){
            if (a.comment) {
                e.report({
                    messageId: "deprecatedSignatureWithReason",
                    node: p,
                    data: {
                        name: m,
                        signature: o.signatureToString(r, t, c.WriteTypeArgumentsOfSignature),
                        reason: u(a.comment)
                    }
                });
                break;
            }
            e.report({
                messageId: "deprecatedSignature",
                node: p,
                data: {
                    name: m,
                    signature: o.signatureToString(r, t, c.WriteTypeArgumentsOfSignature)
                }
            });
        }
        return;
    }
    for (let t of s.getDeclarations() ?? [])for (let r of n(t, i)){
        if (r.comment) {
            e.report({
                messageId: "deprecatedWithReason",
                node: p,
                data: {
                    name: m,
                    reason: u(r.comment)
                }
            });
            return;
        }
        e.report({
            messageId: "deprecated",
            node: p,
            data: {
                name: m
            }
        });
    }
}
export default l({
    name: "deprecation",
    meta: {
        docs: {
            description: "Disallow usage of deprecated APIs",
            requiresTypeChecking: !0
        },
        configurations: {
            recommended: "warn",
            strict: "error"
        },
        messages: {
            deprecated: "'{{name}}' is deprecated.",
            deprecatedWithReason: "'{{name}}' is deprecated: {{reason}}",
            deprecatedSignature: "The signature '{{signature}}' of '{{name}}' is deprecated.",
            deprecatedSignatureWithReason: "The signature '{{signature}}' of '{{name}}' is deprecated: {{reason}}"
        },
        schema: [],
        type: "problem"
    },
    defaultOptions: [],
    create (r) {
        let n = d(r), a = n.program.getTypeChecker();
        return {
            JSXElement (i) {
                let o = a.getSymbolAtLocation(n.esTreeNodeToTSNodeMap.get(i.openingElement.name));
                if (void 0 === o) return;
                let p = a.getContextualType(n.esTreeNodeToTSNodeMap.get(i.openingElement.name.type === t.JSXIdentifier ? i.openingElement.name : i.openingElement.name.type === t.JSXNamespacedName ? i.openingElement.name.name : i.openingElement.name.property));
                void 0 !== p && (i.openingElement.attributes.forEach((i)=>{
                    switch(i.type){
                        case e.AST_NODE_TYPES.JSXAttribute:
                            let o = a.getPropertyOfType(p, i.name.type === t.JSXIdentifier ? i.name.name : i.name.name.name);
                            if (void 0 === o) break;
                            g(r, n, a, i.name, o, "string" == typeof i.name.name ? i.name.name : i.name.name.name);
                        case e.AST_NODE_TYPES.JSXSpreadAttribute:
                    }
                }), g(r, n, a, i.openingElement.name, o, function(t) {
                    switch(t.type){
                        case e.AST_NODE_TYPES.JSXIdentifier:
                            return t.name;
                        case e.AST_NODE_TYPES.JSXMemberExpression:
                            return t.property.name;
                        case e.AST_NODE_TYPES.JSXNamespacedName:
                            return `${t.namespace.name}:${t.name}`;
                    }
                }(i.openingElement.name)));
            },
            Property (e) {
                let i = n.esTreeNodeToTSNodeMap.get(e);
                if (e.key.type === t.Identifier && m(i)) {
                    let t = a.getTypeAtLocation(i.name).getSymbol();
                    if (void 0 === t) return;
                    g(r, n, a, e, t, e.key.name);
                }
            },
            Identifier (e) {
                if (function(e) {
                    switch(e.parent.type){
                        case t.FunctionDeclaration:
                        case t.TSDeclareFunction:
                        case t.ClassDeclaration:
                        case t.TSInterfaceDeclaration:
                        case t.TSTypeAliasDeclaration:
                        case t.Property:
                            return !0;
                        case t.VariableDeclarator:
                            return e.parent.init !== e;
                        case t.TSPropertySignature:
                        case t.PropertyDefinition:
                            return e.parent.key === e;
                    }
                    return !1;
                }(e)) return;
                let i = n.getSymbolAtLocation(e);
                if (void 0 !== i) try {
                    g(r, n, a, e, i, e.name);
                } catch  {
                    return;
                }
            },
            MemberExpression (e) {
                if (e.property.type === t.PrivateIdentifier) {
                    let t = e.property, i = n.getSymbolAtLocation(t);
                    if (void 0 !== i) try {
                        g(r, n, a, t, i, `#${t.name}`);
                    } catch  {
                        return;
                    }
                }
            }
        };
    }
});

//# sourceMappingURL=deprecation.js.map