import { TSESTree as e } from "@typescript-eslint/utils";
import { createRule as t } from "../util/index.js";
export default t({
    meta: {
        fixable: "code",
        messages: {
            expressionStatement: "Singular expression statement in arrow function can be extracted"
        },
        schema: [],
        type: "problem",
        docs: {
            description: "Hi"
        },
        configurations: {
            recommended: "warn",
            strict: "error"
        }
    },
    defaultOptions: [],
    create: (t)=>{
        let r = (r)=>(o)=>{
                let n = [], s = t.sourceCode.getFirstToken(r.body);
                if (null === s) return null;
                let l = t.sourceCode.getTokenAfter(s);
                if (null === l) return null;
                n.push(o.removeRange([
                    s.range[0],
                    l.range[0]
                ])), n.push(o.insertTextBefore(s, "("));
                let u = t.sourceCode.getLastToken(r.body);
                if (null === u) return null;
                let i = t.sourceCode.getTokenBefore(u);
                return null === i ? null : (n.push(o.removeRange([
                    i.range[0] + 1,
                    u.range[1]
                ])), n.push(o.insertTextAfter(u, ")")), i.type === e.AST_TOKEN_TYPES.Punctuator && ";" === i.value && n.push(o.remove(i)), n);
            };
        return {
            ArrowFunctionExpression: (o)=>{
                if (o.body.type == e.AST_NODE_TYPES.BlockStatement && 1 === o.body.body.length && o.body.body[0].type === e.AST_NODE_TYPES.ExpressionStatement) {
                    let e = t.sourceCode.getFirstToken(o.body);
                    if (null === e) throw Error("Token expected");
                    let n = t.sourceCode.getLastToken(o.body);
                    if (null === n) throw Error("Token expected");
                    let s = {
                        start: e.loc.start,
                        end: n.loc.end
                    };
                    t.report({
                        messageId: "expressionStatement",
                        node: o,
                        loc: s,
                        fix: r(o)
                    });
                    return;
                }
            }
        };
    },
    name: "extract-lone-expressions"
});

//# sourceMappingURL=extract-lone-expressions.js.map