import { AST as e } from "vue-eslint-parser";
import { createRule as t } from "../util/index.js";
export default t({
    defaultOptions: [],
    meta: {
        docs: {
            description: "Be sensible with Vue"
        },
        messages: {
            computed: "No computed properties on the class property"
        },
        schema: [],
        type: "problem",
        configurations: {
            recommended: "error",
            strict: "error"
        }
    },
    create: (t)=>({
            Program: (r)=>{
                let o = r.templateBody;
                o && e.traverseNodes(o, {
                    enterNode (e, r) {
                        null !== r && "VExpressionContainer" === r.type && "ObjectExpression" == e.type && e.properties.forEach((e)=>{
                            "Property" == e.type && e.computed && r.parent?.type == "VAttribute" && "VDirectiveKey" == r.parent.key.type && r.parent.key.argument?.type == "VIdentifier" && "class" == r.parent.key.argument.name && t.report({
                                node: e,
                                messageId: "computed"
                            });
                        });
                    },
                    leaveNode: ()=>{}
                });
            }
        }),
    name: "no-class-computed-properties"
});

//# sourceMappingURL=no-class-computed-properties.js.map