import { TSESTree as e } from "@typescript-eslint/utils";
import { createRule as r } from "../util/index.js";
export default r({
    create (r) {
        let t = (t)=>(n)=>{
                let o = [];
                if (null !== t.id) {
                    let u = r.sourceCode.getFirstToken(t.id);
                    if (null === u) return null;
                    o.push(n.insertTextBefore(u, "const ")), o.push(n.insertTextAfter(u, " = "));
                    let s = r.sourceCode.getTokenBefore(u);
                    if (null === s) return null;
                    o.push(n.removeRange([
                        r.sourceCode.getIndexFromLoc(s.loc.start),
                        r.sourceCode.getIndexFromLoc(s.loc.end) + 1
                    ]));
                    let i = r.sourceCode.getTokenBefore(s);
                    i && i.type == e.AST_TOKEN_TYPES.Identifier && "async" == i.value && t.async && (o.push(n.removeRange([
                        i.range[0],
                        i.range[1] + 1
                    ])), o.push(n.insertTextAfter(u, "async ")));
                    let l = r.sourceCode.getFirstToken(t.body);
                    if (null === l) return null;
                    let a = r.sourceCode.getTokenBefore(l);
                    if (null === a) return null;
                    o.push(n.insertTextAfter(a, " =>"));
                }
                return o;
            }, n = (t)=>(n)=>{
                let o = [], u = r.sourceCode.getFirstToken(t);
                if (!u) return null;
                if (u.type == e.AST_TOKEN_TYPES.Keyword && "function" == u.value || u.type == e.AST_TOKEN_TYPES.Identifier && "async" == u.value) {
                    let s = "async" == u.value, i = r.sourceCode.getTokenAfter(u);
                    i && i.type == e.AST_TOKEN_TYPES.Keyword && "function" == i.value ? (r.sourceCode.isSpaceBetween(u, i) ? o.push(n.removeRange([
                        u.range[0],
                        u.range[1] + 1
                    ])) : o.push(n.removeRange([
                        u.range[0],
                        u.range[1]
                    ])), o.push(n.removeRange([
                        i.range[0],
                        i.range[1] + 1
                    ]))) : o.push(n.removeRange([
                        u.range[0],
                        u.range[1]
                    ]));
                    let l = r.sourceCode.getFirstToken(t.body);
                    if (!l) return null;
                    s && o.push(n.insertTextBefore(t, "async ")), o.push(n.insertTextBefore(l, "=> "));
                } else {
                    let s = r.sourceCode.getFirstToken(t.body);
                    if (!s) return null;
                    if (o.push(n.insertTextBefore(s, "=> ")), o.push(n.insertTextBefore(u, ": ")), t.parent.type == e.AST_NODE_TYPES.Property) {
                        let u = t.parent, s = r.sourceCode.getFirstToken(u);
                        s && s.type == e.AST_TOKEN_TYPES.Identifier && "async" == s.value && (o.push(n.removeRange([
                            s.range[0],
                            s.range[1] + 1
                        ])), o.push(n.insertTextBefore(t, "async ")));
                    }
                }
                return o;
            }, o = (t)=>(n)=>{
                let o = [], u = r.sourceCode.getFirstToken(t);
                if (null === u || (u.type === e.AST_TOKEN_TYPES.Identifier && "async" === u.value && (u = r.sourceCode.getTokenAfter(u)), null === u) || u.type !== e.AST_TOKEN_TYPES.Keyword || "function" !== u.value) return null;
                o.push(n.removeRange(u.range));
                let s = r.sourceCode.getFirstToken(t.body);
                return null === s ? null : (o.push(n.insertTextBefore(s, "=> ")), o);
            };
        return {
            FunctionDeclaration: (n)=>{
                let o = n.parent;
                (o.type == e.AST_NODE_TYPES.ExportNamedDeclaration || o.type == e.AST_NODE_TYPES.ExportDefaultDeclaration || o.type == e.AST_NODE_TYPES.Program) && r.report({
                    messageId: "expectArrowFunction",
                    node: n,
                    fix: t(n)
                });
            },
            FunctionExpression: (t)=>{
                let u = t.parent;
                u.type == e.AST_NODE_TYPES.Property || u.type == e.AST_NODE_TYPES.ArrayExpression ? r.report({
                    messageId: "expectArrowFunction",
                    node: t,
                    fix: n(t)
                }) : r.report({
                    messageId: "expectArrowFunction",
                    node: t,
                    fix: o(t)
                });
            }
        };
    },
    defaultOptions: [],
    meta: {
        messages: {
            expectArrowFunction: "Expected arrow function, found function declaration"
        },
        schema: [],
        type: "problem",
        fixable: "code",
        docs: {
            description: "Correct function declarations"
        },
        configurations: {
            recommended: "warn",
            strict: "error"
        }
    },
    name: "no-func-declaration"
});

//# sourceMappingURL=no-func-declaration.js.map