import { AST_NODE_TYPES as e, ESLintUtils as r } from "@typescript-eslint/utils";
import { createRule as t } from "../util/index.js";
export default t({
    name: "no-multiple-array-check",
    meta: {
        messages: {
            arrayEvery: "Move OR and AND conditions on the results of array.every into the callback function",
            arraySome: "Move OR and AND conditions on the results of array.some into the callback function"
        },
        schema: [],
        type: "problem",
        docs: {
            description: "Hi"
        },
        configurations: {
            recommended: "warn",
            strict: "error"
        }
    },
    defaultOptions: [],
    create: (t)=>{
        let o = r.getParserServices(t);
        return {
            LogicalExpression: (r)=>{
                let a = [
                    r.left,
                    r.right
                ].map((r)=>{
                    if (r.type === e.CallExpression && r.callee.type === e.MemberExpression) {
                        let e = o.getTypeAtLocation(r.callee.object);
                        if (void 0 === e) return !1;
                        if (e.getSymbol()?.getName() === "Array") {
                            let e = o.getSymbolAtLocation(r.callee);
                            return void 0 !== e && e.getName();
                        }
                    }
                    return !1;
                }).reduce((e, r)=>{
                    switch(typeof e){
                        case "string":
                            return e === r && e;
                        case "boolean":
                            return !1;
                    }
                });
                "some" === a ? t.report({
                    messageId: "arraySome",
                    node: r
                }) : "every" === a && t.report({
                    messageId: "arrayEvery",
                    node: r
                });
            }
        };
    }
});

//# sourceMappingURL=no-multiple-array-check.js.map