import { AST_NODE_TYPES as e } from "@typescript-eslint/utils";
import { createRule as t } from "../util/index.js";
export default t({
    name: "no-nested-ifs",
    meta: {
        messages: {
            nestedIf: "Please merge nested if statements"
        },
        schema: [],
        type: "problem",
        docs: {
            description: "Hi"
        },
        configurations: {
            recommended: "warn"
        }
    },
    defaultOptions: [],
    create: (t)=>({
            IfStatement: (s)=>{
                s.parent.type === e.IfStatement && t.report({
                    messageId: "nestedIf",
                    node: s
                });
            }
        })
});

//# sourceMappingURL=no-nested-ifs.js.map