import { ESLintUtils as e } from "@typescript-eslint/utils";
import { createRule as r } from "../util/index.js";
export default r({
    defaultOptions: [],
    meta: {
        docs: {
            description: "new Promise() can result in unreadable code"
        },
        messages: {
            promiseConstructor: "new Promise() is disallowed syntax"
        },
        schema: [],
        type: "problem",
        configurations: {
            recommended: "warn",
            strict: "error"
        }
    },
    name: "no-new-promise",
    create: (r)=>{
        let o = e.getParserServices(r);
        return {
            NewExpression: (e)=>{
                "PromiseConstructor" === o.getTypeAtLocation(e.callee).symbol.escapedName.toString() && r.report({
                    messageId: "promiseConstructor",
                    node: e.callee
                });
            }
        };
    }
});

//# sourceMappingURL=no-new-promise.js.map