import { AST_NODE_TYPES as e } from "@typescript-eslint/utils";
import { createRule as t } from "../util/index.js";
export default t({
    name: "no-relative-imports",
    meta: {
        messages: {
            declaration: "Do not use relative imports to import from parent directories, always use absolute paths",
            expression: "Do not use relative imports to import from parent directories, always use absolute paths"
        },
        schema: [
            {
                type: "object",
                properties: {
                    allowParentImports: {
                        type: "boolean",
                        description: "Allow ../ relative imports"
                    }
                },
                additionalProperties: !1
            }
        ],
        type: "problem",
        docs: {
            description: "Hi"
        },
        configurations: {
            recommended: "warn",
            strict: "error"
        }
    },
    create: (t)=>{
        let o = !1;
        t.options.length >= 1 && (o = t.options[0].allowParentImports);
        let r = (e, r, s)=>{
            e.startsWith("..") && !o && t.report({
                node: r,
                messageId: s
            });
        };
        return {
            ImportDeclaration: (e)=>{
                r(e.source.value, e.source, "declaration");
            },
            ImportExpression: (t)=>{
                t.source.type === e.Literal && "string" == typeof t.source.value && r(t.source.value, t.source, "expression");
            }
        };
    },
    defaultOptions: [
        {
            allowParentImports: !0
        }
    ]
});

//# sourceMappingURL=no-relative-imports.js.map